%% ------  Lezione 1, 3 ottobre 2016 ------ 
% Visualizzazione e grafica 2D-3D

clear all;
close all;
clc;

A = randn(100,100); % controllare nell'help la differenza fra la
% funzione randn e la funzione rand che abbiamo usato in precedenza
fprintf('Elemento A(1,1) = %i\n',A(1,1));

% Controllare varie modalita' di esecuzione di comandi 
% (evidenziare una riga quindi F9, oppure tasto destro 
% --> Evaluate selection);
fprintf('Elemento A(1,1) = %2.3f\n',A(1,1));

% Modalita' di debug: selezionare il '-' 
% accanto al numero della riga di interesse;

B = A+A; % ispezionare il contenuto di B da modalita' di debug

figure; % apro una nuova figura
imagesc(B); 
colorbar;  % prestare attenzione al range di visualizzazione;
title('Visualizzazione di una matrice');

%Visualizzo una sottomatrice
C=B(80:end,80:end);
figure; 
imagesc(C);
colorbar;
title('Visualizzazione di una sottomatrice');

%Visualizzo piu' sottomatrici
% subplot:
% - primo argomento: numero di righe in cui suddividere la
% - secondo argomento: numero di colonne in cui suddividere la figura
% - terzo argomento: la cella dove disegnare la figura
figure; 
subplot(1,2,1); imagesc(B(1:20,1:20));
subplot(1,2,2); imagesc(B(1:20,80:end));
suptitle('Visualizzazione di piu sottomatrici');
% provate qui sopra a visualizzare i valori degli 
% elementi in figura direttamente dalla figura, 
% con l'apposito operatore data cursor (una delle icone
% nella barra in alto)

D = imread('cameraman.tif'); % Un'immagine è una matrice!
% In particolare, un'immagine in bianco e nero è una matrice
% in cui ogni cella indica la "luminosità" del pixel corrispondente
% L'immagine 'cameraman.tif' è un'immagine di esempio in Matlab
figure;
imagesc(D), colormap gray; % visualizza in bianco e nero
title('Visualizzazione di immagini');
colorbar

figure;
surf(double(D)); shading interp; colormap gray
title('Comando surf');

% Plot della prima riga dell'immagine, la interpreto come se fossero i valori
% sull'asse y di una funzione
[r,c] = size(D); % Estraggo il numero di colonne
x = 1:c;         % Vettore di interi da 1 a c
y = D(1,:);      % Prima riga dell'immagine
figure;
plot(x,y), title('Intensita'' dei pixel lungo una riga');

%% Esercizio:

% 1) Data l'immagine del cameraman, sostituire un "blocco" dell'immagine
% (ad esempio le prime 50 righe e le prime 50 colonne) con degli uni,
% e visualizzare l'immagine così ottenuta

% 2) Fate un figura con 2 subplot: un imagesc di una
% matrice random (usare rand), e il plot di una funzione 
% (es. coseno da -pi a pi)

% Ricordatevi i comandi:
% rand
% figure
% subplot
% imagesc
% plot
% linspace
% cos



